package SliMP3::Discovery;

# $Id: Discovery.pm,v 1.15 2003/05/20 19:43:44 blackketter Exp $

# SliMP3 Server Copyright (C) 2001 Sean Adams, Slim Devices Inc.
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License, 
# version 2.

use strict;

use IO::Socket;
use SliMP3::Misc;

# Respond to a hello received from a client
#        
sub gotHello {
	my($client) = @_;
	$::d_protocol && msg(SliMP3::Client::id($client) . " Client says hello\n");
}

# Say hello to a client
#
sub sayHello {
	my $udpsock = shift;
	my $addr = shift;
	my ($ip, $port) = split( /:/, $addr);

	$::d_protocol && msg($ip . " Saying hello to: $ip, $port\n");
	
	$ip = inet_aton($ip);
	my $paddr = sockaddr_in($port, $ip);
	
	$udpsock->send( 'h'.(pack('C', 0) x 17), 0, $paddr);
}

#
# send the discovery response
#
sub sendDiscoveryResponse {
	my $udpsock = shift;
	my $clientpaddr = shift;

	my $response = 'D'. (pack('C', 0) x 17);
	
	$::d_protocol && msg(" send discovery response\n");

	$udpsock->send( $response, 0, $clientpaddr);
}

#
# We received a discovery request
#
sub gotDiscoveryRequest {
	my $udpsock = shift;
	my $clientpaddr = shift;

	$::d_protocol && msg(" Got discovery request\n");
	&sendDiscoveryResponse($udpsock, $clientpaddr);
}

1;
